# coding: utf-8

"""
    Gitea API.

    This documentation describes the Gitea API.

    The version of the OpenAPI document: 1.19.4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import List, Optional
from pydantic import BaseModel, StrictStr, conlist
from py_gitea_opensuse_org.models.commit_meta import CommitMeta
from py_gitea_opensuse_org.models.commit_user import CommitUser

class FileCommitResponse(BaseModel):
    """
    FileCommitResponse
    """
    author: Optional[CommitUser] = None
    committer: Optional[CommitUser] = None
    created: Optional[datetime] = None
    html_url: Optional[StrictStr] = None
    message: Optional[StrictStr] = None
    parents: Optional[conlist(CommitMeta)] = None
    sha: Optional[StrictStr] = None
    tree: Optional[CommitMeta] = None
    url: Optional[StrictStr] = None
    __properties = ["author", "committer", "created", "html_url", "message", "parents", "sha", "tree", "url"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> FileCommitResponse:
        """Create an instance of FileCommitResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of author
        if self.author:
            _dict['author'] = self.author.to_dict()
        # override the default output from pydantic by calling `to_dict()` of committer
        if self.committer:
            _dict['committer'] = self.committer.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in parents (list)
        _items = []
        if self.parents:
            for _item in self.parents:
                if _item:
                    _items.append(_item.to_dict())
            _dict['parents'] = _items
        # override the default output from pydantic by calling `to_dict()` of tree
        if self.tree:
            _dict['tree'] = self.tree.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> FileCommitResponse:
        """Create an instance of FileCommitResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return FileCommitResponse.parse_obj(obj)

        _obj = FileCommitResponse.parse_obj({
            "author": CommitUser.from_dict(obj.get("author")) if obj.get("author") is not None else None,
            "committer": CommitUser.from_dict(obj.get("committer")) if obj.get("committer") is not None else None,
            "created": obj.get("created"),
            "html_url": obj.get("html_url"),
            "message": obj.get("message"),
            "parents": [CommitMeta.from_dict(_item) for _item in obj.get("parents")] if obj.get("parents") is not None else None,
            "sha": obj.get("sha"),
            "tree": CommitMeta.from_dict(obj.get("tree")) if obj.get("tree") is not None else None,
            "url": obj.get("url")
        })
        return _obj


