# coding: utf-8

"""
    Gitea API.

    This documentation describes the Gitea API.

    The version of the OpenAPI document: 1.19.4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, StrictStr
from py_gitea_opensuse_org.models.commit_meta import CommitMeta

class Tag(BaseModel):
    """
    Tag represents a repository tag
    """
    commit: Optional[CommitMeta] = None
    id: Optional[StrictStr] = None
    message: Optional[StrictStr] = None
    name: Optional[StrictStr] = None
    tarball_url: Optional[StrictStr] = None
    zipball_url: Optional[StrictStr] = None
    __properties = ["commit", "id", "message", "name", "tarball_url", "zipball_url"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Tag:
        """Create an instance of Tag from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of commit
        if self.commit:
            _dict['commit'] = self.commit.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Tag:
        """Create an instance of Tag from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Tag.parse_obj(obj)

        _obj = Tag.parse_obj({
            "commit": CommitMeta.from_dict(obj.get("commit")) if obj.get("commit") is not None else None,
            "id": obj.get("id"),
            "message": obj.get("message"),
            "name": obj.get("name"),
            "tarball_url": obj.get("tarball_url"),
            "zipball_url": obj.get("zipball_url")
        })
        return _obj


